import es
import playerlib
import vecmath
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "dod_flag_captured_custom_event"
info.version = "1.0"
info.author = "EmbouT"
info.url = "http://mattie.info/forums/"
info.description = "Provides an event of the flag captured with the correct cappers userid"
info.tags = "DoD:S"



es.loadevents("declare", "addons/eventscripts/dod_flag_captured_custom_event/dod_flag_captured_custom_event.res")

def es_map_start(event_var):
    es.loadevents("declare", "addons/eventscripts/dod_flag_captured_custom_event/dod_flag_captured_custom_event.res")

def dod_round_start(event_var):
    global area_zone
    area_zone={}
    dcp=es.createentitylist('dod_control_point')
    dca=es.createentitylist('dod_capture_area')
    for point in dcp:
        for area in dca:
            area_min = dca[area]["CBaseEntity.m_Collision.m_vecMins"].split(',')
            area_max = dca[area]["CBaseEntity.m_Collision.m_vecMaxs"].split(',')
            for i in (0,1,2):
                area_min[i] = float(area_min[i])-15.0
                area_max[i] = float(area_max[i])+15.0
            if vecmath.isbetweenRect(vecmath.vector(dcp[point]["CBaseAnimating.baseclass.m_vecOrigin"].split(',')),vecmath.vector(area_min),vecmath.vector(area_max)):
                area_zone[point] = [dcp[point]["CBaseAnimating.m_nBody"],area_min,area_max]

def dod_point_captured(event_var):
    global area_zone
    cappers=''
    for point in area_zone:
        body=es.getindexprop(point,"CBaseAnimating.m_nBody")
        if body != area_zone[point][0]:
            area_zone[point][0]=body
            for player in playerlib.getUseridList('#alive,#t' if body else '#alive,#ct'):
                if vecmath.isbetweenRect(vecmath.vector(es.getplayerlocation(player)),vecmath.vector(area_zone[point][1]),vecmath.vector(area_zone[point][2])):
                    cappers+=str(player)+','

            es.event("initialize", "dod_flag_captured")
            es.event("setint","dod_flag_captured","cp",event_var['cp'])
            es.event("setstring","dod_flag_captured","cpname",event_var['cpname'])
            es.event("setstring","dod_flag_captured","cappers",cappers[:-1])
            es.event("setint","dod_flag_captured","bomb",event_var['bomb'])
            es.event("fire", "dod_flag_captured")
